Attribute VB_Name = "ACTCP"
Declare Function TCPAccept Lib "actcp32" ( _
                 ByVal nStream As Integer) As Integer

Declare Function TCPCancel Lib "actcp32" ( _
                 ByVal nStream As Integer) As Boolean

Declare Function TCPClose Lib "actcp32" ( _
                 ByVal nStream As Integer) As Boolean

Declare Function TCPConnect Lib "actcp32" ( _
                 ByVal strServerName As String, _
                 ByVal strServiceName As String) As Integer

Declare Function TCPGetClientInfo Lib "actcp32" ( _
                 ByVal nStream As Integer, _
                 ByVal strIPNumber As String, _
                 ByVal nLen As Integer) As Boolean
                 
Declare Function TCPGetHostName Lib "actcp32" ( _
                 ByVal strHostName As String, _
                 ByVal nLen As Integer) As Boolean

Declare Function TCPGetLastError Lib "actcp32" ( _
                 ByVal strError As String, _
                 ByVal nLen As Integer) As Integer

Declare Function TCPGetSocket Lib "actcp32" ( _
                 ByVal nStream As Integer) As Long
                 
Declare Function TCPHostName2IPNumber Lib "actcp32" ( _
                 ByVal strHostName As String, _
                 ByVal strIPNumber As String, _
                 ByVal nLen As Long) As Boolean
                 
Declare Function TCPIPNumber2HostName Lib "actcp32" ( _
                 ByVal strIPNumber As String, _
                 ByVal strHostName As String, _
                 ByVal nLen As Long) As Boolean
                 
Declare Function TCPListen Lib "actcp32" ( _
                 ByVal strServiceName As String, _
                 ByVal nQueue As Integer, _
                 ByVal hwnd As Long) As Integer

Declare Function TCPRead Lib "actcp32" ( _
                 ByVal nStream As Integer, _
                 ByVal strData As String, _
                 ByVal nSize As Integer) As Integer

Declare Sub TCPSetTrace Lib "actcp32" ( _
                 ByVal fDoTrace As Boolean)

Declare Function TCPWrite Lib "actcp32" ( _
                 ByVal nStream As Integer, _
                 ByVal strData As String, _
                 ByVal nSize As Integer) As Integer
                                                 

Sub ShowError()
  Dim mErrorNum As Integer
  Dim mErrorStr As String * 1024
  
  ' This function is used to get the last error number and message
  ' that occurred during one of the client/server functions.
  mErrorNum = TCPGetLastError(mErrorStr, 1024)
  If (mErrorNum > 0) Then
    MsgBox "TCP Error " + Str(mErrorNum) + ":  " + mErrorStr
  End If
  
End Sub

