// mtsdlg.cpp : implementation file
//

#include "stdafx.h"
#include "tcpmts.h"
#include "mtsdlg.h"

#include <afxconv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static int _convert;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMTSDlg dialog

CMTSDlg::CMTSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMTSDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMTSDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMTSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMTSDlg)
	DDX_Control(pDX, IDC_BTN_STOP, m_StopButton);
	DDX_Control(pDX, IDC_BTN_RUN, m_RunButton);
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Control(pDX, IDC_TOT_SESSIONS, m_nTotClients);
	DDX_Control(pDX, IDC_SERVICE, m_ServiceName);
	DDX_Control(pDX, IDC_NCLIENTS, m_nClients);
	DDX_Control(pDX, IDC_ACTCPX, m_actcpx);
	DDX_Control(pDX, IDC_LINE0, m_lines[0]);
	DDX_Control(pDX, IDC_LINE1, m_lines[1]);
	DDX_Control(pDX, IDC_LINE2, m_lines[2]);
	DDX_Control(pDX, IDC_LINE3, m_lines[3]);
	DDX_Control(pDX, IDC_LINE4, m_lines[4]);
	DDX_Control(pDX, IDC_LINE5, m_lines[5]);
	DDX_Control(pDX, IDC_LINE6, m_lines[6]);
	DDX_Control(pDX, IDC_LINE7, m_lines[7]);
	DDX_Control(pDX, IDC_LINE8, m_lines[8]);
	DDX_Control(pDX, IDC_LINE9, m_lines[9]);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMTSDlg, CDialog)
	//{{AFX_MSG_MAP(CMTSDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_RUN, OnBtnRun)
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMTSDlg message handlers

BOOL CMTSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ServiceName.SetWindowText("1600"); // set a default service
	m_RunButton.EnableWindow(TRUE);
	m_StopButton.EnableWindow(FALSE);
	m_Status.ShowWindow(SW_HIDE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMTSDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMTSDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMTSDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CMTSDlg::OnBtnRun() 
{
	CString m_str;

	m_ServiceName.GetWindowText(m_str);

    if (m_str.IsEmpty()) {
		::MessageBox(NULL, "Please specify a service name", 
			(LPCTSTR) m_str, MB_OK);
		return;
	}
	
	m_actcpx.TCPRunServer((LPCTSTR) m_str, 20);
	m_numClients = 0;
    m_nTotal = 0;
	m_RunButton.EnableWindow(FALSE);
	m_StopButton.EnableWindow(TRUE);
	m_Status.ShowWindow(SW_SHOW);
}

BEGIN_EVENTSINK_MAP(CMTSDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMTSDlg)
	ON_EVENT(CMTSDlg, IDC_ACTCPX, 1 /* ServiceClient */, OnACTCPServiceClient, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CMTSDlg::OnACTCPServiceClient(long nStream) 
{
    BSTR    strInData;
	BSTR    strIP;
    CString m_strIP = "";
	int     nIndex = (nStream - 1) % 10;
	char    m_buffer[200];
	
	//
	// Get the client IP number
	//
	m_actcpx.TCPGetClientInfo(nStream, &strIP);
    m_strIP = W2A(strIP);

    m_numClients++;
	sprintf(m_buffer, "%d", m_numClients);
	m_nClients.SetWindowText(m_buffer);
	m_nClients.UpdateWindow();

    m_nTotal++;
	sprintf(m_buffer, "%d", m_nTotal);
	m_nTotClients.SetWindowText(m_buffer);
	m_nTotClients.UpdateWindow();

	int count = 0;

	while (TRUE /*count++ <= 10*/) {
	    int nBytes = m_actcpx.TCPRead(nStream, &strInData, 100);

		if (nBytes == 0) {
			continue;
		}

		count += nBytes;;

		if (strstr(W2A(strInData), "QUIT") != NULL) {
			//
			// confirm receipt of the QUIT message
			//
			break;
		}

		sprintf(m_buffer, "%s     %s [%d]", 
			   (LPCTSTR) m_strIP, W2A(strInData), count);

		m_lines[nIndex].SetWindowText(m_buffer);
		m_lines[nIndex].UpdateWindow();

	    m_actcpx.TCPWrite(nStream, "OK", 2);
	}

	sprintf(m_buffer, "Server received %d bytes from %s.", 
		   count, (LPCTSTR) m_strIP);

	m_lines[nIndex].SetWindowText(m_buffer);
	m_lines[nIndex].UpdateWindow();

	m_actcpx.TCPWrite(nStream, "OK", 2);
	m_actcpx.TCPClose(nStream);

	//
	// Update the display of concurrent clients
	//
    m_numClients--;
	sprintf(m_buffer, "%d", m_numClients);
	m_nClients.SetWindowText(m_buffer);
	m_nClients.UpdateWindow();

	//
	// Free up the BSTR objects 
	//
	SysFreeString(strInData);
	SysFreeString(strIP);
}


void CMTSDlg::OnBtnStop() 
{
    m_actcpx.TCPTerminateServer();	
	m_numClients = 0;
    m_nTotal = 0;

	m_RunButton.EnableWindow(TRUE);
	m_StopButton.EnableWindow(FALSE);
	m_Status.ShowWindow(SW_HIDE);

	m_nClients.SetWindowText("0");
	m_nClients.UpdateWindow();
	m_nTotClients.SetWindowText("0");
	m_nTotClients.UpdateWindow();
}
